package JavaCode;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.StringTokenizer;


/*
SLIDER: Local Short Reads DNA Sequence Alignment
Beta Release; Ver 0.1, 22th Mar. 2008
By: Nawar Malhis
Canada's Michael Smith Genome Sciences Centre
*/

public class Alignment {
	static ReferenceSequences rs;
	
	static       String[] files;
	
	public static void main(String[] args) throws Exception {
		int ux;
		if (args.length < 1) {
			return;
		}
		Parameters.read(args[0]); 
		int[] refSeqSize = new int[Parameters.SEQ_VAR.length];

		files       = new String[Parameters.SEQ_VAR.length];
		Parameters.resetTime();
		Oligo.numberOfBACs = Parameters.SEQ_VAR.length;
		Oligo.BACs = Parameters.SEQ_VAR;
		ReferenceSequences.display = false;
		//*
		if (args.length < 2) {
			// System.err.println("Section 1:");
			rs = new ReferenceSequences();
			rs.fillCode();
			ux = 0;
			ReferenceSequences.ux = ux;
			Parameters.delete(Parameters.pathOut);
			getRefSeqSize(Parameters.pathDB + Parameters.DATABASE, files, refSeqSize);
			
			rs.align(Parameters.pathDB + Parameters.DATABASE, Parameters.pathData, Parameters.pathOut, Parameters.outFile,  ux);
			System.err.print("time Aligning " + ux + ":");		
			Parameters.printTime(Parameters.numberOfTimePoints - 2);
			System.err.println();
			
			rs.subtractID (Parameters.pathData + Parameters.outFile + ".ol" + ux, Parameters.pathOut + Parameters.outFile + ".ol" + (ux+1));
			System.err.print("time subtractID " + ux + ":");		
			Parameters.printTime(Parameters.numberOfTimePoints - 2);
			System.err.println();

			rs = null;
			System.gc();
			// Parameters.displayMemory("Section\t1\tPoint\t4");
			// System.err.println(" --- Break point 1 ---");
		}
		//*/
		if (args.length < 3) {
			// System.err.println("Section 2:");
			// Parameters.displayMemory("Section\t2\tPoint\t1");
			rs = new ReferenceSequences();
			rs.fillCode();
			ux = 1;
			// Parameters.displayMemory("Section\t2\tPoint\t2");
			ReferenceSequences.ux = ux;
			rs.align(Parameters.pathDB + Parameters.DATABASE, Parameters.pathOut, Parameters.pathOut, Parameters.outFile, ux);
			System.err.print("time Aligning " + ux + ":");		
			Parameters.printTime(Parameters.numberOfTimePoints - 2);
			System.err.println();
			// Parameters.displayMemory("Section\t2\tPoint\t3");
			rs = null;
			System.gc();
			// Parameters.displayMemory("Section\t2\tPoint\t4");
			// System.err.println(" --- Break point 2 ---");
		}
		
		Oligo.sortIndex = Oligo.ID;
		Parameters.delete(Parameters.pathOut + "s.ol1");
		
		OligoFile.sort_file(Parameters.pathOut + Parameters.outFile + ".m0", Oligo.ID);
		Parameters.delete(Parameters.pathOut + Parameters.outFile + ".m0");
		
		OligoFile.sort_file(Parameters.pathOut + Parameters.outFile + ".m1", Oligo.ID);
		Parameters.delete(Parameters.pathOut + Parameters.outFile + ".m1");

		System.err.print("time Sorting:");	
		Runtime.getRuntime().exec("rmdir " + Parameters.pathOut + "s.ol1");
		Runtime.getRuntime().exec("rmdir " + Parameters.pathOut + "s.m0");
		Runtime.getRuntime().exec("rmdir " + Parameters.pathOut + "s.m1");

		Parameters.printTime(Parameters.numberOfTimePoints - 2);
		System.err.println();

		System.err.print("\nTotal Execution time is: ");
		Parameters.printTime(Parameters.numberOfTimePoints - 1);
		System.err.println();
	}	
	static void getRefSeqSize(String dbfile, String[] fls, int[] refSeqSize) throws Exception {
		String line;
		StringTokenizer tokens;
		rs.refSeqSize = new int[refSeqSize.length];
		// System.err.println(dbfile + "refSeqSizes");
		BufferedReader reader = new BufferedReader(new FileReader(dbfile + "refSeqSizes"));
		for (int i = 0; i < refSeqSize.length; i++) {
			System.err.print(i + "\tSize:\t");
			line           = reader.readLine();
			tokens         = new StringTokenizer(line);	
			rs.refSeqSize[i] = refSeqSize[i]      = new Integer(tokens.nextToken());
			System.err.println(refSeqSize[i]);
		}
		reader.close();
	}
	static void nextU(String pathD, String pathO, String dt, int ux) throws Exception {
		System.gc();
		ReferenceSequences.subResult = ReferenceSequences.NM;
		rs.subtractSQ2f1(
				pathO + dt + ".ol" + (ux + 1) + ".mu", 
				pathD + dt + ".ol" + ux, 
				pathO + dt + ".ol" + (ux + 1), 
				pathO + dt + ".ol" + (ux + 1) + ".m", 
				ux); 
		System.gc();
		System.err.print("time subtractSQ2f1:\t");		
		Parameters.printTime(Parameters.numberOfTimePoints - 2);
		System.err.println();
		//*/
	}
	static void clean() throws Exception {
		System.runFinalization();
		System.gc();
		Parameters.delete(Parameters.pathOut + "s.ol1.mu/");
		Runtime.getRuntime().exec("rmdir " + Parameters.pathOut + "s.ol1.mu/");
	}
}
